#if !defined(__BC_H__)
#define      __BC_H__

#include "globals.h"
#include "utils/graphIO.h"
#include "representations/tradArrayNoDegGraphR.h"

using namespace std;

class BC {
 public:
  void setOpenmpConfig(int dynamic, int threads);
  void runPushWithOpenMP(TradArrayNoDegGraphR* G_csr, v_id ROOT, v_id** bfs_out);
  void runPullWithOpenMP(TradArrayNoDegGraphR* G_csr, v_id ROOT, v_id** bfs_out);
  int64_t verify_bfs_tree (int64_t *bfs_tree_in, int64_t max_bfsvtx, int64_t root, const int64_t *IJ_in, int64_t nedge);
  int compute_levels (int64_t * level, int64_t nv, const int64_t * bfs_tree, int64_t root);

  void setRunID(int run_id) {this->run_id = run_id;}

  int run_id;
};

#endif
